<script lang="ts">
  import { Alert, Badge, Table } from 'sveltestrap';
  import type { ScoreboardFeedback } from '@models/ScoreboardFeedback';
  import { Gql } from '../../db';
  import Feedback from './Feedback.svelte';
  import { KeycloakStore, KeycloakInterface } from '@auth/keycloak';
  import type { Team } from '@models/Team';
  import BlueteamSelect from '../Utils/BlueteamSelect.svelte';

  let isStaff: boolean = false;
  let selectedTeam: Team | null = null;
  let queryRole: string | null = null;
  let scoreboardFeedback: Array<ScoreboardFeedback> | null = null;
  const serviceName: Map<number, string> = new Map<number, string>();
  let blueteams: Array<Team> = [];
  let keycloak: KeycloakInterface;

  // we need to add staff here but while it works in hasura,  it doesn't here
  function scoreboardFeedbackQuery(team: string, isStaffQuery: boolean): string {
    // Exclude staff in request if not staff or GQL query will fail
    let ret = `query teamfeedback {
            current_service_status (where: {team_name: {_eq: ${team}}}) {
                service_name
                service_id
                participant
                `;
    if (isStaffQuery) {
      ret += ' staff ';
    }
    ret += '}}';
    return ret;
  }

  async function initServiceNames() {
    if (serviceName.size < 1) {
      const q = `query service {
                service {
                    display_name
                    id
                }
            }`;
      await Gql.query(q)
        .then((res) => {
          (res as { service: Array<{ id: number; display_name: string }> }).service.forEach((e) => {
            serviceName.set(e.id, e.display_name);
          });
        })
        .catch((err: Array<Error>) => {
          console.log(`${err[0].message}: ${q}`);
        });
    }
  }

  async function initScoreboardFeedback() {
    if (selectedTeam == null) {
      return Promise.resolve(null);
    }
    const q = scoreboardFeedbackQuery(selectedTeam.name, isStaff);
    try {
      await initServiceNames();
      let newdata: Array<ScoreboardFeedback> | null = null;
      if (queryRole) {
        Gql.query(q, { role: queryRole }).then((res) => {
          newdata = (res as { current_service_status: Array<ScoreboardFeedback> }).current_service_status;
          if (newdata.length < 1) {
            return Promise.resolve(null);
          }
          newdata.forEach((e) => {
            e.serviceName = serviceName.get(e.service_id) || e.serviceName;
          });
          scoreboardFeedback = newdata;
        });
      } else {
        Gql.query(q).then((res) => {
          newdata = (res as { current_service_status: Array<ScoreboardFeedback> }).current_service_status;
          if (newdata.length < 1) {
            return Promise.resolve(null);
          }
          newdata.forEach((e) => {
            e.serviceName = serviceName.get(e.service_id) || e.serviceName;
          });
          scoreboardFeedback = newdata;
        });
      }
    } catch (err: Array<Error>) {
      // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
      console.log(`${err[0].message}: ${q}`);
    }
  }

  KeycloakStore.subscribe((value) => {
    keycloak = value!!.keycloak;
    const teamId = keycloak?.teamID;
    if (!selectedTeam && teamId) {
      const team = blueteams.find((t) => t.id === teamId);
      selectedTeam = team || null;
    }

    isStaff = keycloak.isRole('blackteam') || keycloak.isRole('admin');
    if (isStaff) {
      if (keycloak.isRole('admin')) {
        queryRole = 'admin';
      } else if (keycloak.isRole('blackteam')) {
        queryRole = 'blackteam';
      } else {
        queryRole = null;
      }
    }
    initScoreboardFeedback();
  });
</script>

<BlueteamSelect bind:selectedTeam bind:blueteams on:click={initScoreboardFeedback} />

<!-- If we dont see the staff property default to participant -->
{#key selectedTeam}
  {#if scoreboardFeedback !== null && scoreboardFeedback.length > 0}
    <Table>
      <tbody>
        {#each scoreboardFeedback as sf}
          <!-- Header Row -->
          <tr><td><h5>{sf.serviceName}</h5></td></tr>

          <!-- Participant Feedback Row -->
          <tr>
            <td>
              {#if sf.participant}
                <Feedback feedback={sf.participant} />
              {:else}
                <Alert color="warning">No Feedback Available!</Alert>
              {/if}
            </td>
          </tr>

          <!-- Staff Feedback -->
          {#if isStaff && sf.staff}
            <tr>
              <td class="border border-warning">
                <Badge color="warning">Staff Feedback</Badge>
                <Feedback feedback={sf.staff} />
              </td>
            </tr>
          {/if}
        {/each}
      </tbody>
    </Table>
  {:else if selectedTeam !== null}
    <p>No feedback available.</p>
  {/if}
{/key}

<style>
  /* Unset row-specific items for this component */
  .table tbody tr:hover {
    background-color: unset;
  }

  .table tbody tr:nth-of-type(2n + 1) {
    background-color: unset;
  }
</style>
